<?php if (!defined('SMP_VER')) exit('restricted access');
/*
 * @package WordPress
 * @subpackage Simp Modal Window
*/
	// add action register our post type popups
	add_action( 'init', 'register_cpt_simp_modal' );

	// Register our Custom Post type as popups
	function register_cpt_simp_modal() {
		
		// labels text for our post type popups
		$labels = array(
			// post type general name
			'name' => __( 'Simp Popups', SMP_NAME ),
			// post type singular name
			'singular_name' => __( 'Simp Popup', SMP_NAME ),
			'add_new' => __( 'Add New Popup', SMP_NAME ),
			'add_new_item' => __( 'Add New Popup', SMP_NAME ),
			'edit_item' => __( 'Edit Popup', SMP_NAME ),
			'new_item' => __( 'New Popup', SMP_NAME ),
			'view_item' => __( 'View Popup', SMP_NAME ),
			'search_items' => __( 'Search Popups', SMP_NAME ),
			'not_found' =>  __( 'No Popups found', SMP_NAME ),
			'not_found_in_trash' => __( 'No Popups found in Trash', SMP_NAME ),
			'parent_item_colon' => '',
			'menu_name' => 'Simp Popups'
		);
		
		$args = array(
			'labels' => $labels,
			'public' => true,
			'publicly_queryable' => true,
			'show_ui' => true,
			'query_var' => true,
			'show_in_nav_menus' => false,
			'exclude_from_search' => true,
			'menu_icon' => SMP_URL .'/images/icon.png',
			'capability_type' => 'post',
			'hierarchical' => false,
			'has_archive' => false,
			'menu_position' => 6,
			'supports' => array( 'title', 'editor', 'revisions' ),
			'rewrite' => true
		);	
		register_post_type( 'popups' , $args );
	}
	
	// add action for customize simp_modal columns layout
	add_filter( 'manage_edit-popups_columns', 'simp_modal_edit_columns' );
	add_action( 'manage_posts_custom_column',  'simp_modal_custom_columns' );

	function simp_modal_edit_columns( $columns ) {
		$columns = array(
			'cb' => '<input type="checkbox" />',
			'title' => 'Title',
			'type' => 'Display',
			'cookie' => 'Cookie',
			'date' => 'Date'
		);
		return $columns;
	}
	
	// edit default columns add our custom columns
	function simp_modal_custom_columns( $column ) {
		global $post, $post_ID;
		
		$set = get_post_meta( $post->ID, 'popup_set_meta', true );
		
		switch ( $column ) {
			case 'type' :
				$display = $set['display'];
				switch ($display) {
					// disabled
					case 'no' : echo 'Disabled'; break;
					// display onclick
					case 'click' : echo 'On Click'; break;
					// display on page load
					case 'load' : echo 'On Page Load'; break;
					// display on page unload
					case 'unload' : echo 'On Close Window'; break;
					// timout 5 seconds
					case 'load5s' : echo 'Display after 5 seconds'; break;
					// timout 10 seconds
					case 'load10s' : echo 'Display after 10 seconds'; break;
					// timout 15 seconds
					case 'load15s' : echo 'Display after 15 seconds'; break;
					// timout 20 seconds
					case 'load20s' : echo 'Display after 20 seconds'; break;
					// timout 30 seconds
					case 'load30s' : echo 'Display after 30 seconds'; break;
					// timout 45 seconds
					case 'load45s' : echo 'Display after 45 seconds'; break;
					// timout 1 minute
					case 'load1m' : echo 'Display after 1 minute'; break;
					// timout 2 minutes
					case 'load2m' : echo 'Display after 2 minutes'; break;
					// timout 3 minutes
					case 'load3m' : echo 'Display after 3 minutes'; break;
					// timout 5 minutes
					case 'load5m' : echo 'Display after 5 minutes'; break;
				}
			break;
			
			case 'cookie' :
				$cookie = $set['cookie'];
				$cookie_dur = $set['cookie_dur'];
				$cookie_date = $set['cookie_date'];
				
				// check if cookie enabled
				if ($cookie == 'yes') {
					
					switch ($cookie_dur) {
						// show once a year
						case '1time' : echo 'Display Once'; break;
						// show after every 6 hours
						case '6hr' : echo 'Display Again After Every 6 Hours'; break;
						// show after every 12 hours
						case '12hr' : echo 'Display Again After Every 12 Hours'; break;
						// show after every 24 hours
						case '24hr' : echo 'Display Again After Every 24 Hours'; break;
						// show after every 2 days
						case '2day' : echo 'Display Again After Every 2 Days'; break;
						// show after every 3 days
						case '3day' : echo 'Display Again After Every 3 Days'; break;
						// show after every week
						case '1week' : echo 'Display Again After Every 1 Week'; break;
						// show after every 2 weeks
						case '2week' : echo 'Display Again After Every 2 Weeks'; break;
						// show after every 1 month
						case 'month' : echo 'Display Again After Every 1 Month'; break;
						// show after specific time
						case 'expire' : echo 'Display Again at ' .$cookie_date; break;
					}
				} else {
					echo 'cookie not enabled, display on each pageview.';
				}
			break;
		}
	}

	// popups meta box hook into WordPress
	add_action( 'admin_init', 'add_simp_modal_metabox' );

	// Add meta box
	function add_simp_modal_metabox() {
		add_meta_box( 'simp_modal_meta_box', __( 'Modal Window Settings', SMP_NAME ), 'create_simp_modal_settings', 'popups', 'normal', 'core' );
	}

	function create_simp_modal_settings() {
		global $post, $post_ID;
		
		// get values from our meta fields
		$modal = get_post_meta( $post->ID, 'popup_design_meta', true );
		$width = $modal['width'];
		$height = $modal['height'];
		$units = $modal['units'];
		$padding = $modal['padding'];
		$background = $modal['background'];
		$border_radius = $modal['border_radius'];
		$border = $modal['border'];
		$border_style = $modal['border_style'];
		$border_color = $modal['border_color'];
		$overlay = $modal['overlay'];
		$overlay_opacity = $modal['overlay_opacity'];
		$overlay_color = $modal['overlay_color'];
		$shadow = $modal['shadow'];
		$shadow_opacity = $modal['shadow_opacity'];
		$shadow_color = $modal['shadow_color'];
		$close = $modal['close'];
		$close_position = $modal['close_position'];
		$close_icon = $modal['close_icon'];
		$custom_css = $modal['custom_css'];
		
		// get modal settings meta
		$set = get_post_meta( $post->ID, 'popup_set_meta', true );
		$display = $set['display'];
		$display_on = $set['display_on'];
		$display_button = $set['display_button'];
		$display_ids = $set['display_ids'];
		$close_msg = $set['close_msg'];
		$auto = $set['auto'];
		$counter = $set['counter'];
		$counter_c = $set['counter_c'];
		$cookie = $set['cookie'];
		$cookie_dur = $set['cookie_dur'];
		$cookie_date = $set['cookie_date'];
		$transition = $set['transition'];
		$animation = $set['animation'];
		$hide_click = $set['hide_click'];
		
		// generate HTML for our meta box ?>
		<div class="admin-inside-box clearfix">
			<input type="hidden" name="popups_nonce" value="<?php echo wp_create_nonce( basename(__FILE__) ); ?>" />
			<ul class="smp-tabs">
				<li class="active">
					<a href="#tab-design">
						<h4 class="tab-title"><?php _e('Modal Design', SMP_NAME); ?></h4>
					</a>
				</li>
				<li>
					<a href="#tab-settings">
						<h4 class="tab-title"><?php _e('Modal Settings', SMP_NAME); ?></h4>
					</a>
				</li>
			</ul>
			<div class="tab-container">
				<ul id="tab-design" class="tab-content">
					<li>
						<div class="smp-label"><label><?php _e('Modal Layout', SMP_NAME); ?></label></div>
						<div class="smp-1">
							<input type="text" class="text" name="modal[width]" value="<?php echo $width ?>" />
							<span class="desc"><?php _e('enter popup width in pixels e.g(380)', SMP_NAME); ?>.</span>
						</div>
						<div class="smp-1">
							<input type="text" class="text" name="modal[height]" value="<?php echo $height ?>" />
							<span class="desc"><?php _e('enter popup height in pixels e.g(240)', SMP_NAME); ?>.</span>
						</div>
						<div class="smp-1">
							<select class="p-select" name="modal[units]">
								<option value="pix"<?php if ($units == 'pix') echo ' selected="selected"'; ?>><?php _e('Pixels', SMP_NAME); ?></option>
								<option value="per"<?php if ($units == 'per') echo ' selected="selected"'; ?>><?php _e('Percentage', SMP_NAME); ?></option>
							</select>
							<span class="desc"><?php _e('select measurement units for width, height and padding', SMP_NAME); ?>.</span>
						</div>
						<div class="smp-label"></div>
						<div class="smp-1">
							<input type="text" class="text" name="modal[padding]" value="<?php echo $padding ?>" />
							<span class="desc"><?php _e('enter popup padding e.g(10)', SMP_NAME); ?>.</span>
						</div>
						<div class="smp-1">
							<input type="text" class="text" name="modal[border_radius]" value="<?php echo $border_radius ?>" />
							<span class="desc"><?php _e('enter popup border radius e.g(5)', SMP_NAME); ?>.</span>
						</div>
						<div class="smp-1">
							<input type="text" class="color-pick" name="modal[background]" value="<?php echo $background ?>" />
							<span class="desc"><?php _e('choose modal background color', SMP_NAME); ?>.</span>
						</div>
					</li>
					<li>
						<div class="smp-label"><label><?php _e('Modal Border', SMP_NAME); ?></label></div>
						<div class="smp-1">
							<select class="p-select" name="modal[border]" id="br-select">
								<option value="none"<?php if ($border == 'none') echo ' selected="selected"'; ?>><?php _e('None', SMP_NAME); ?></option>
								<option value="1px"<?php if ($border == '1px') echo ' selected="selected"'; ?>><?php _e('1 pixel', SMP_NAME); ?></option>
								<option value="2px"<?php if ($border == '2px') echo ' selected="selected"'; ?>><?php _e('2 pixel', SMP_NAME); ?></option>
								<option value="3px"<?php if ($border == '3px') echo ' selected="selected"'; ?>><?php _e('3 pixel', SMP_NAME); ?></option>
								<option value="4px"<?php if ($border == '4px') echo ' selected="selected"'; ?>><?php _e('4 pixel', SMP_NAME); ?></option>
								<option value="5px"<?php if ($border == '5px') echo ' selected="selected"'; ?>><?php _e('5 pixel', SMP_NAME); ?></option>
								<option value="6px"<?php if ($border == '6px') echo ' selected="selected"'; ?>><?php _e('6 pixel', SMP_NAME); ?></option>
								<option value="8px"<?php if ($border == '8px') echo ' selected="selected"'; ?>><?php _e('8 pixel', SMP_NAME); ?></option>
								<option value="10px"<?php if ($border == '10px') echo ' selected="selected"'; ?>><?php _e('10 pixel', SMP_NAME); ?></option>
							</select>
							<span class="desc"><?php _e('select popup border thickness', SMP_NAME); ?>.</span>
						</div>
						<div class="smp-1" id="br-st" style="display:none;">
							<select class="p-select" name="modal[border_style]">
								<option value="solid"<?php if ($border_style == 'solid') echo ' selected="selected"'; ?>><?php _e('Solid', SMP_NAME); ?></option>
								<option value="dotted"<?php if ($border_style == 'dotted') echo ' selected="selected"'; ?>><?php _e('Dotted', SMP_NAME); ?></option>
								<option value="dashed"<?php if ($border_style == 'dashed') echo ' selected="selected"'; ?>><?php _e('Dashed', SMP_NAME); ?></option>
							</select>
							<span class="desc"><?php _e('choose popup border style', SMP_NAME); ?>.</span>
						</div>
						<div class="smp-1" id="br-cp" style="display:none;">
							<input type="text" class="color-pick" name="modal[border_color]" value="<?php echo $border_color ?>" />
							<span class="desc"><?php _e('choose a border color', SMP_NAME); ?>.</span>
						</div>
					</li>
					<li>
						<div class="smp-label"><label><?php _e('Background Overlay', SMP_NAME); ?></label></div>
						<div class="smp-1">
							<select class="p-select" name="modal[overlay]" id="ol-select">
								<option value="yes"<?php if ($overlay == 'yes') echo ' selected="selected"'; ?>><?php _e('Yes', SMP_NAME); ?></option>
								<option value="no"<?php if ($overlay == 'no') echo ' selected="selected"'; ?>><?php _e('No', SMP_NAME); ?></option>
							</select>
							<span class="desc"><?php _e('select background overlay', SMP_NAME); ?>.</span>
						</div>
						<div class="smp-1" id="ol-op" style="display:none;">
							<select class="p-select" name="modal[overlay_opacity]">
								<option value="1"<?php if ($overlay_opacity == '1') echo ' selected="selected"'; ?>>100%</option>
								<option value=".9"<?php if ($overlay_opacity == '.9') echo ' selected="selected"'; ?>>90%</option>
								<option value=".8"<?php if ($overlay_opacity == '.8') echo ' selected="selected"'; ?>>80%</option>
								<option value=".7"<?php if ($overlay_opacity == '.7') echo ' selected="selected"'; ?>>70%</option>
								<option value=".6"<?php if ($overlay_opacity == '.6') echo ' selected="selected"'; ?>>60%</option>
								<option value=".5"<?php if ($overlay_opacity == '.5') echo ' selected="selected"'; ?>>50%</option>
								<option value=".4"<?php if ($overlay_opacity == '.4') echo ' selected="selected"'; ?>>40%</option>
								<option value=".3"<?php if ($overlay_opacity == '.3') echo ' selected="selected"'; ?>>30%</option>
								<option value=".2"<?php if ($overlay_opacity == '.2') echo ' selected="selected"'; ?>>20%</option>
								<option value=".1"<?php if ($overlay_opacity == '.1') echo ' selected="selected"'; ?>>10%</option>
							</select>
							<span class="desc"><?php _e('choose overlay opacity', SMP_NAME); ?>.</span>
						</div>
						<div class="smp-1" id="ol-cp" style="display:none;">
							<input type="text" class="color-pick" name="modal[overlay_color]" value="<?php echo $overlay_color ?>" />
							<span class="desc"><?php _e('choose overlay background color', SMP_NAME); ?>.</span>
						</div>
					</li>
					<li>
						<div class="smp-label"><label><?php _e('Modal Box Shadow', SMP_NAME); ?></label></div>
						<div class="smp-1">
							<select class="p-select" name="modal[shadow]" id="bs-select">
								<option value="no"<?php if ($shadow == 'no') echo ' selected="selected"'; ?>><?php _e('None', SMP_NAME); ?></option>
								<option value="1px"<?php if ($shadow == '1px') echo ' selected="selected"'; ?>>1px</option>
								<option value="2px"<?php if ($shadow == '2px') echo ' selected="selected"'; ?>>2px</option>
								<option value="3px"<?php if ($shadow == '3px') echo ' selected="selected"'; ?>>3px</option>
								<option value="4px"<?php if ($shadow == '4px') echo ' selected="selected"'; ?>>4px</option>
								<option value="5px"<?php if ($shadow == '5px') echo ' selected="selected"'; ?>>5px</option>
								<option value="6px"<?php if ($shadow == '6px') echo ' selected="selected"'; ?>>6px</option>
								<option value="8px"<?php if ($shadow == '8px') echo ' selected="selected"'; ?>>8px</option>
								<option value="10px"<?php if ($shadow == '10px') echo ' selected="selected"'; ?>>10px</option>
								<option value="12px"<?php if ($shadow == '12px') echo ' selected="selected"'; ?>>12px</option>
								<option value="15px"<?php if ($shadow == '15px') echo ' selected="selected"'; ?>>15px</option>
								<option value="20px"<?php if ($shadow == '20px') echo ' selected="selected"'; ?>>20px</option>
							</select>
							<span class="desc"><?php _e('select box shadow', SMP_NAME); ?>.</span>
						</div>
						<div class="smp-1" id="bs-op" style="display:none;">
							<select class="p-select" name="modal[shadow_opacity]">
								<option value="1"<?php if ($shadow_opacity == '1') echo ' selected="selected"'; ?>>100%</option>
								<option value=".9"<?php if ($shadow_opacity == '.9') echo ' selected="selected"'; ?>>90%</option>
								<option value=".8"<?php if ($shadow_opacity == '.8') echo ' selected="selected"'; ?>>80%</option>
								<option value=".7"<?php if ($shadow_opacity == '.7') echo ' selected="selected"'; ?>>70%</option>
								<option value=".6"<?php if ($shadow_opacity == '.6') echo ' selected="selected"'; ?>>60%</option>
								<option value=".5"<?php if ($shadow_opacity == '.5') echo ' selected="selected"'; ?>>50%</option>
								<option value=".4"<?php if ($shadow_opacity == '.4') echo ' selected="selected"'; ?>>40%</option>
								<option value=".35"<?php if ($shadow_opacity == '.35') echo ' selected="selected"'; ?>>35%</option>
								<option value=".3"<?php if ($shadow_opacity == '.3') echo ' selected="selected"'; ?>>30%</option>
								<option value=".25"<?php if ($shadow_opacity == '.25') echo ' selected="selected"'; ?>>25%</option>
								<option value=".2"<?php if ($shadow_opacity == '.2') echo ' selected="selected"'; ?>>20%</option>
								<option value=".15"<?php if ($shadow_opacity == '.15') echo ' selected="selected"'; ?>>15%</option>
								<option value=".1"<?php if ($shadow_opacity == '.1') echo ' selected="selected"'; ?>>10%</option>
							</select>
							<span class="desc"><?php _e('choose box shadow opacity', SMP_NAME); ?>.</span>
						</div>
						<div class="smp-1" id="bs-cp" style="display:none;">
							<input type="text" class="color-pick" name="modal[shadow_color]" value="<?php echo $shadow_color ?>" />
							<span class="desc"><?php _e('choose box shadow color', SMP_NAME); ?>.</span>
						</div>
					</li>
					<li>
						<div class="smp-label"><label><?php _e('Modal Close Icon', SMP_NAME); ?></label></div>
						<div class="smp-1">
							<select class="p-select" name="modal[close]" id="cl-select">
								<option value="yes"<?php if ($close == 'yes') echo ' selected="selected"'; ?>><?php _e('Show Icon', SMP_NAME); ?></option>
								<option value="no"<?php if ($close == 'no') echo ' selected="selected"'; ?>><?php _e('Hide Icon', SMP_NAME); ?></option>
							</select>
							<span class="desc"><?php _e('show or hide close icon', SMP_NAME); ?>.</span>
						</div>
						<div class="smp-1" id="cl-ps" style="display:none;">
							<select class="p-select" name="modal[close_position]">
								<option value="tl"<?php if ($close_position == 'tl') echo ' selected="selected"'; ?>><?php _e('Top Left', SMP_NAME); ?></option>
								<option value="tr"<?php if ($close_position == 'tr') echo ' selected="selected"'; ?>><?php _e('Top Right', SMP_NAME); ?></option>
								<option value="bl"<?php if ($close_position == 'bl') echo ' selected="selected"'; ?>><?php _e('Bottom Left', SMP_NAME); ?></option>
								<option value="br"<?php if ($close_position == 'br') echo ' selected="selected"'; ?>><?php _e('Bottom Right', SMP_NAME); ?></option>
							</select>
							<span class="desc"><?php _e('select close icon position', SMP_NAME); ?>.</span>
						</div>
						<div class="smp-1" id="cl-ic" style="display:none;">
							<span class="icon-select">
								<img class="close-icon<?php if ($close_icon == '1') echo ' selected'; ?>" src="<?php echo SMP_URL ?>images/close1.png" alt="close icon" />
								<input type="radio" class="p-radio" name="modal[close_icon]" value="1"<?php if ($close_icon == '1') echo ' checked="checked"'; ?> />
							</span>
							<span class="icon-select">
								<img class="close-icon<?php if ($close_icon == '2') echo ' selected'; ?>" src="<?php echo SMP_URL ?>images/close2.png" alt="close icon" />
								<input type="radio" class="p-radio" name="modal[close_icon]" value="2"<?php if ($close_icon == '2') echo ' checked="checked"'; ?> />
							</span>
							<span class="icon-select">
								<img class="close-icon<?php if ($close_icon == '3') echo ' selected'; ?>" src="<?php echo SMP_URL ?>images/close3.png" alt="close icon" />
								<input type="radio" class="p-radio" name="modal[close_icon]" value="3"<?php if ($close_icon == '3') echo ' checked="checked"'; ?> />
							</span>
							<span class="icon-select">
								<img class="close-icon<?php if ($close_icon == '4') echo ' selected'; ?>" src="<?php echo SMP_URL ?>images/close4.png" alt="close icon" />
								<input type="radio" class="p-radio" name="modal[close_icon]" value="4"<?php if ($close_icon == '4') echo ' checked="checked"'; ?> />
							</span>
							<span class="icon-select">
								<img class="close-icon<?php if ($close_icon == '5') echo ' selected'; ?>" src="<?php echo SMP_URL ?>images/close5.png" alt="close icon" />
								<input type="radio" class="p-radio" name="modal[close_icon]" value="5"<?php if ($close_icon == '5') echo ' checked="checked"'; ?> />
							</span>
							<span class="icon-select" style="margin-right:0;">
								<img class="close-icon<?php if ($close_icon == '6') echo ' selected'; ?>" src="<?php echo SMP_URL ?>images/close6.png" alt="close icon" />
								<input type="radio" class="p-radio" name="modal[close_icon]" value="6"<?php if ($close_icon == '6') echo ' checked="checked"'; ?> />
							</span>
							<span class="desc"><?php _e('choose close icon, click to select', SMP_NAME); ?>.</span>
						</div>
					</li>
					<li>
						<div class="smp-label"><label><?php _e('Content CSS Styles', SMP_NAME); ?></label></div>
						<div class="smp-2">
							<textarea class="text" name="modal[custom_css]" style="height:100px;"><?php echo $custom_css ?></textarea>
							<span class="desc"><?php _e('add your custom CSS Styles for popup contents', SMP_NAME); ?>.</span>
						</div>
					</li>
				</ul>
				<!-- END tab-design -->
				
				<ul id="tab-settings" class="tab-content">
					<li>
						<div class="smp-label"><label><?php _e('Modal Display', SMP_NAME); ?></label></div>
						<div class="smp-1">
							<select class="p-select" name="set[display]" id="dm-select">
								<option value="no"<?php if ($display == 'no') echo ' selected="selected"'; ?>><?php _e('Disable', SMP_NAME); ?></option>
								<option value="click"<?php if ($display == 'click') echo ' selected="selected"'; ?>><?php _e('Display On Click', SMP_NAME); ?></option>
								<option value="load"<?php if ($display == 'load') echo ' selected="selected"'; ?>><?php _e('Display On Page Load', SMP_NAME); ?></option>
								<option value="unload"<?php if ($display == 'unload') echo ' selected="selected"'; ?>><?php _e('Display On Close Window', SMP_NAME); ?></option>
								<option value="load5s"<?php if ($display == 'load5s') echo ' selected="selected"'; ?>><?php _e('Display After 5 Seconds', SMP_NAME); ?></option>
								<option value="load10s"<?php if ($display == 'load10s') echo ' selected="selected"'; ?>><?php _e('Display After 10 Seconds', SMP_NAME); ?></option>
								<option value="load15s"<?php if ($display == 'load15s') echo ' selected="selected"'; ?>><?php _e('Display After 15 Seconds', SMP_NAME); ?></option>
								<option value="load20s"<?php if ($display == 'load20s') echo ' selected="selected"'; ?>><?php _e('Display After 20 Seconds', SMP_NAME); ?></option>
								<option value="load30s"<?php if ($display == 'load30s') echo ' selected="selected"'; ?>><?php _e('Display After 30 Seconds', SMP_NAME); ?></option>
								<option value="load45s"<?php if ($display == 'load45s') echo ' selected="selected"'; ?>><?php _e('Display After 45 Seconds', SMP_NAME); ?></option>
								<option value="load1m"<?php if ($display == 'load1m') echo ' selected="selected"'; ?>><?php _e('Display After 1 Minute', SMP_NAME); ?></option>
								<option value="load2m"<?php if ($display == 'load2m') echo ' selected="selected"'; ?>><?php _e('Display After 2 Minutes', SMP_NAME); ?></option>
								<option value="load3m"<?php if ($display == 'load3m') echo ' selected="selected"'; ?>><?php _e('Display After 3 Minutes', SMP_NAME); ?></option>
								<option value="load5m"<?php if ($display == 'load5m') echo ' selected="selected"'; ?>><?php _e('Display After 5 Minutes', SMP_NAME); ?></option>
							</select>
							<span class="desc"><?php _e('modal display method', SMP_NAME); ?>.</span>
						</div>
						<div class="smp-1" id="dm-db" style="display:none;">
							<input type="text" class="text" name="set[display_button]" value="<?php echo $display_button ?>" />
							<span class="desc"><?php _e('if onclick selected, add button id e.g(#button)', SMP_NAME); ?>.</span>
						</div>
						<div class="smp-1" id="dm-cm" style="display:none;">
							<textarea class="text" name="set[close_msg]" style="height:100px;"><?php echo $close_msg ?></textarea>
							<span class="desc"><?php _e('alert message, if on close window selected', SMP_NAME); ?>.</span>
						</div>
						<div class="smp-1">
							<?php // get all pages
							$pages = get_pages('sort_column=ID'); ?>
							<select class="p-select" name="set[display_on]" id="do-select">
								<option value="index-page"<?php if ($display_on == 'index-page') echo ' selected="selected"'; ?>><?php _e('Posts Index Page', SMP_NAME); ?></option>
								<option value="all-pages"<?php if ($display_on == 'all-pages') echo ' selected="selected"'; ?>><?php _e('All Pages', SMP_NAME); ?></option>
								<option value="all-posts"<?php if ($display_on == 'all-posts') echo ' selected="selected"'; ?>><?php _e('All Posts', SMP_NAME); ?></option>
								<option value="pages-posts"<?php if ($display_on == 'pages-posts') echo ' selected="selected"'; ?>><?php _e('All Pages and Posts', SMP_NAME); ?></option>
								<option value="archive"<?php if ($display_on == 'archive') echo ' selected="selected"'; ?>><?php _e('On Archive Pages', SMP_NAME); ?></option>
								<option value="search"<?php if ($display_on == 'search') echo ' selected="selected"'; ?>><?php _e('On Search Pages', SMP_NAME); ?></option>
								<option value="only-specific"<?php if ($display_on == 'only-specific') echo ' selected="selected"'; ?>><?php _e('Show on Specific IDs', SMP_NAME); ?></option>
								<option value="exc-specific"<?php if ($display_on == 'exc-specific') echo ' selected="selected"'; ?>><?php _e('Hide on Specific IDs', SMP_NAME); ?></option>
								<?php foreach ( $pages as $page ) { 
									$page_id = $page->ID;
									$page_title = $page->post_title; ?>
									<option value="<?php echo $page_id ?>"<?php if ($display_on == $page_id) echo ' selected="selected"'; ?>><?php echo $page_title; ?></option>
									<?php
								} ?>
							</select>
							<span class="desc"><?php _e('select where display popup', SMP_NAME); ?>.</span>
						</div>
						<div class="smp-1" id="do-di" style="display:none;">
							<textarea class="text" name="set[display_ids]" style="height:100px;"><?php echo $display_ids ?></textarea>
							<span class="desc"><?php _e('comma-separated page, post IDs', SMP_NAME); ?>.</span>
						</div>
					</li>
					<li>
						<div class="smp-label"><label><?php _e('Auto Close', SMP_NAME); ?></label></div>
						<div class="smp-1">
							<select class="p-select" name="set[auto]" id="at-select">
								<option value="no"<?php if ($auto == 'no') echo ' selected="selected"'; ?>><?php _e('No', SMP_NAME); ?></option>
								<option value="5"<?php if ($auto == '5') echo ' selected="selected"'; ?>><?php _e('After 5 Seconds', SMP_NAME); ?></option>
								<option value="10"<?php if ($auto == '10') echo ' selected="selected"'; ?>><?php _e('After 10 Seconds', SMP_NAME); ?></option>
								<option value="15"<?php if ($auto == '15') echo ' selected="selected"'; ?>><?php _e('After 15 Seconds', SMP_NAME); ?></option>
								<option value="20"<?php if ($auto == '20') echo ' selected="selected"'; ?>><?php _e('After 20 Seconds', SMP_NAME); ?></option>
								<option value="25"<?php if ($auto == '25') echo ' selected="selected"'; ?>><?php _e('After 25 Seconds', SMP_NAME); ?></option>
								<option value="30"<?php if ($auto == '30') echo ' selected="selected"'; ?>><?php _e('After 30 Seconds', SMP_NAME); ?></option>
								<option value="40"<?php if ($auto == '40') echo ' selected="selected"'; ?>><?php _e('After 40 Seconds', SMP_NAME); ?></option>
								<option value="45"<?php if ($auto == '45') echo ' selected="selected"'; ?>><?php _e('After 45 Seconds', SMP_NAME); ?></option>
								<option value="50"<?php if ($auto == '50') echo ' selected="selected"'; ?>><?php _e('After 50 Seconds', SMP_NAME); ?></option>
								<option value="60"<?php if ($auto == '60') echo ' selected="selected"'; ?>><?php _e('After 1:00 Minute', SMP_NAME); ?></option>
								<option value="90"<?php if ($auto == '90') echo ' selected="selected"'; ?>><?php _e('After 1:30 Minute', SMP_NAME); ?></option>
								<option value="120"<?php if ($auto == '120') echo ' selected="selected"'; ?>><?php _e('After 2:00 Minutes', SMP_NAME); ?></option>
								<option value="150"<?php if ($auto == '150') echo ' selected="selected"'; ?>><?php _e('After 2:30 Minutes', SMP_NAME); ?></option>
								<option value="180"<?php if ($auto == '180') echo ' selected="selected"'; ?>><?php _e('After 3:00 Minutes', SMP_NAME); ?></option>
								<option value="240"<?php if ($auto == '240') echo ' selected="selected"'; ?>><?php _e('After 4:00 Minutes', SMP_NAME); ?></option>
								<option value="300"<?php if ($auto == '300') echo ' selected="selected"'; ?>><?php _e('After 5:00 Minutes', SMP_NAME); ?></option>
							</select>
							<span class="desc"><?php _e('set auto close settings', SMP_NAME); ?>.</span>
						</div>
						<div class="smp-1" id="ct-st" style="display:none;">
							<select class="p-select" name="set[counter]" id="ct-select">
								<option value="no"<?php if ($counter == 'no') echo ' selected="selected"'; ?>><?php _e('No', SMP_NAME); ?></option>
								<option value="tl"<?php if ($counter == 'tl') echo ' selected="selected"'; ?>><?php _e('Top Left', SMP_NAME); ?></option>
								<option value="tr"<?php if ($counter == 'tr') echo ' selected="selected"'; ?>><?php _e('Top Right', SMP_NAME); ?></option>
								<option value="bl"<?php if ($counter == 'bl') echo ' selected="selected"'; ?>><?php _e('Bottom Left', SMP_NAME); ?></option>
								<option value="br"<?php if ($counter == 'br') echo ' selected="selected"'; ?>><?php _e('Bottom Right', SMP_NAME); ?></option>
							</select>
							<span class="desc"><?php _e('auto close counter display', SMP_NAME); ?>.</span>
						</div>
						<div class="smp-1" id="ct-cp" style="display:none;">
							<input type="text" class="color-pick" name="set[counter_c]" value="<?php echo $counter_c ?>" />
							<span class="desc"><?php _e('select counter color', SMP_NAME); ?>.</span>
						</div>
					</li>
					<li>
						<div class="smp-label"><label><?php _e('Set Cookie', SMP_NAME); ?></label></div>
						<div class="smp-1">
							<select class="p-select" name="set[cookie]" id="ck-select">
								<option value="no"<?php if ($cookie == 'no') echo ' selected="selected"'; ?>><?php _e('No', SMP_NAME); ?></option>
								<option value="yes"<?php if ($cookie == 'yes') echo ' selected="selected"'; ?>><?php _e('Yes', SMP_NAME); ?></option>
							</select>
							<span class="desc"><?php _e('set cookie in user browser', SMP_NAME); ?>.</span>
						</div>
						<div class="smp-1" id="ck-cd" style="display:none;">
							<select class="p-select" name="set[cookie_dur]" id="cd-select">
								<option value="1time"<?php if ($cookie_dur == '1time') echo ' selected="selected"'; ?>><?php _e('Show Once', SMP_NAME); ?></option>
								<option value="6hr"<?php if ($cookie_dur == '6hr') echo ' selected="selected"'; ?>><?php _e('Show Every 6 Hours', SMP_NAME); ?></option>
								<option value="12hr"<?php if ($cookie_dur == '12hr') echo ' selected="selected"'; ?>><?php _e('Show Every 12 Hours', SMP_NAME); ?></option>
								<option value="24hr"<?php if ($cookie_dur == '24hr') echo ' selected="selected"'; ?>><?php _e('Show Every 24 Hours', SMP_NAME); ?></option>
								<option value="2day"<?php if ($cookie_dur == '2day') echo ' selected="selected"'; ?>><?php _e('Show Every 2 Days', SMP_NAME); ?></option>
								<option value="3day"<?php if ($cookie_dur == '3day') echo ' selected="selected"'; ?>><?php _e('Show Every 3 Days', SMP_NAME); ?></option>
								<option value="1week"<?php if ($cookie_dur == '1week') echo ' selected="selected"'; ?>><?php _e('Show Once a Week', SMP_NAME); ?></option>
								<option value="2week"<?php if ($cookie_dur == '2week') echo ' selected="selected"'; ?>><?php _e('Show Once 2 Weeks', SMP_NAME); ?></option>
								<option value="month"<?php if ($cookie_dur == 'month') echo ' selected="selected"'; ?>><?php _e('Show Once a Month', SMP_NAME); ?></option>
								<option value="expire"<?php if ($cookie_dur == 'expire') echo ' selected="selected"'; ?>><?php _e('Show Again After Date', SMP_NAME); ?></option>
							</select>
							<span class="desc"><?php _e('display modal once or after selected date', SMP_NAME); ?>.</span>
						</div>
						<div class="smp-1" id="ck-dp" style="display:none;">
							<input type="text" class="text datepicker" name="set[cookie_date]" value="<?php echo $cookie_date ?>" />
							<span class="desc"><?php _e('select cookie expiry date', SMP_NAME); ?>.</span>
						</div>
					</li>
					<li>
						<div class="smp-label"><label><?php _e('Display Settings', SMP_NAME); ?></label></div>
						<div class="smp-1">
							<select class="p-select" name="set[transition]">
								<option value="none"<?php if ($transition == 'none') echo ' selected="selected"'; ?>><?php _e('None', SMP_NAME); ?></option>
								<option value="fade"<?php if ($transition == 'fade') echo ' selected="selected"'; ?>><?php _e('Fade', SMP_NAME); ?></option>
								<option value="fadeAndPop"<?php if ($transition == 'fadeAndPop') echo ' selected="selected"'; ?>><?php _e('Fade And Pop', SMP_NAME); ?></option>
							</select>
							<span class="desc"><?php _e('select transition type', SMP_NAME); ?>.</span>
						</div>
						<div class="smp-1">
							<select class="p-select" name="set[animation]">
								<option value="100"<?php if ($animation == '100') echo ' selected="selected"'; ?>><?php _e('100 MS', SMP_NAME); ?></option>
								<option value="200"<?php if ($animation == '200') echo ' selected="selected"'; ?>><?php _e('200 MS', SMP_NAME); ?></option>
								<option value="300"<?php if ($animation == '300') echo ' selected="selected"'; ?>><?php _e('300 MS', SMP_NAME); ?></option>
								<option value="400"<?php if ($animation == '400') echo ' selected="selected"'; ?>><?php _e('400 MS', SMP_NAME); ?></option>
								<option value="500"<?php if ($animation == '500') echo ' selected="selected"'; ?>><?php _e('500 MS', SMP_NAME); ?></option>
								<option value="600"<?php if ($animation == '600') echo ' selected="selected"'; ?>><?php _e('600 MS', SMP_NAME); ?></option>
								<option value="800"<?php if ($animation == '800') echo ' selected="selected"'; ?>><?php _e('800 MS', SMP_NAME); ?></option>
								<option value="1000"<?php if ($animation == '1000') echo ' selected="selected"'; ?>><?php _e('1000 MS', SMP_NAME); ?></option>
							</select>
							<span class="desc"><?php _e('select animation speed', SMP_NAME); ?>.</span>
						</div>
						<div class="smp-1">
							<select class="p-select" name="set[hide_click]">
								<option value="true"<?php if ($hide_click == 'true') echo ' selected="selected"'; ?>><?php _e('Yes', SMP_NAME); ?></option>
								<option value="false"<?php if ($hide_click == 'false') echo ' selected="selected"'; ?>><?php _e('No', SMP_NAME); ?></option>
							</select>
							<span class="desc"><?php _e('close on overlay click', SMP_NAME); ?>.</span>
						</div>
					</li>
				</ul>
				<!-- END tab-settings -->
			</div>
			<!-- END tab-container -->
		</div><?php
	}
	
	// Process the popups metabox fields
	add_action( 'save_post', 'save_simp_modal_settings' );

	function save_simp_modal_settings( $post_id ) {
		global $post, $post_ID;
		
		// verify nonce
		if ( !wp_verify_nonce( $_POST['popups_nonce'], basename(__FILE__) ) ) {
			return $post_id;
		}
		// check if current user can edit post
		if ( $_POST['post_type'] == 'popups' ) {
			if ( !current_user_can( 'edit_post', $post_id ) )
			return $post_id;
		}
		
		// update our meta values
		if( $_POST['post_type'] == 'popups' ) {
			
			$post_id = $_POST['post_ID'];
			
			// create an array of our input values
			$design_data = array();
			foreach($_POST['modal'] as $key => $value) {
				$design_data[$key] = $value;
			}
			
			// create an array of our input values
			$settings = array();
			foreach($_POST['set'] as $key => $value) {
				$settings[$key] = $value;
			}
			
			// save all data into a single posts meta key
			update_post_meta( $post_id, 'popup_design_meta', $design_data );
			update_post_meta( $post_id, 'popup_set_meta', $settings );
		}
	}
	
	// add action to print simp modal scripts and styles in post editing
	add_action( 'admin_print_scripts-post-new.php', 'add_simp_modal_scripts', 11 );
	add_action( 'admin_print_scripts-post.php', 'add_simp_modal_scripts', 11 );	
	
	// enqueue simp modal backend scripts and styles
	function add_simp_modal_scripts() {
		global $post;
		
		if ( $post->post_type == 'popups' ) {
			
			// enqueue new wp color picker css
			wp_enqueue_style( 'wp-color-picker' );
			// enqueue new wp color picker script
			wp_enqueue_script( 'wp-color-picker' );
			// enqueue datepicker css
			wp_enqueue_style( 'datepicker-css', SMP_URL .'css/jquery-ui-custom.css' );
			// enqueue jquery ui datepicker
			wp_enqueue_script( 'jquery-ui-datepicker' );
			
			// enqueue simp modal custom css
			wp_enqueue_style( 'simp-style', SMP_URL .'css/smp-post.css' );
			// enqueue simp modal custom script
			wp_enqueue_script( 'simp-script', SMP_URL .'js/smp-post.js' );
		}
	}
?>